// ReportDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Report.h"
#include "ReportDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CReportDlg dialog

CReportDlg::CReportDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CReportDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CReportDlg)
	m_DateTime = COleDateTime::GetCurrentTime();
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CReportDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CReportDlg)
	DDX_Control(pDX, IDC_LIST_REPORT, m_Report);
	DDX_DateTimeCtrl(pDX, IDC_DATETIMEPICKER1, m_DateTime);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CReportDlg, CDialog)
	//{{AFX_MSG_MAP(CReportDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_NOTIFY(DTN_DATETIMECHANGE, IDC_DATETIMEPICKER1, OnDatetimechangeDatetimepicker1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CReportDlg message handlers

BOOL CReportDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Comment this to take the current date
	m_DateTime.SetDateTime(2006,12,29,10,0,0);
	
	// TODO: Add extra initialization here
	m_Report.InsertColumn(0,"Openion",LVCFMT_LEFT,130);
	m_Report.InsertColumn(1,"Poll",LVCFMT_LEFT,60);
	OnDatetimechangeDatetimepicker1(NULL,NULL);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CReportDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CReportDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CReportDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CReportDlg::OnDatetimechangeDatetimepicker1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	if(pResult)
		*pResult = 0;

	UpdateData();
	m_Report.DeleteAllItems();
	
	CString str;
	CString logfile;

	// prepare log file name
	logfile.Format("logs\\%4d%02d%02d",m_DateTime.GetYear(),m_DateTime.GetMonth(),m_DateTime.GetDay());

	try {
		int pos;
		char userid[50];
		char pin[10];
		int option;
		int choice;
		int result1[6];
		int result2[6];
		int invalid;

		invalid = 0;
		ZeroMemory(result1,sizeof(int) * 6);
		ZeroMemory(result2,sizeof(int) * 6);

		// tag "<info>" is used only for parsing purpose
		CStdioFile xfile(logfile,CFile::modeRead);
		while(xfile.ReadString(str)) {
			pos = str.Find("<info>");
			if(pos == -1)
				continue;

			// found a valid entry. start processing
			str = str.Mid(pos + strlen("<info>") + 1);
			if(sscanf(str,"%s %s %d %d",userid,pin,&option,&choice) != 4)
				continue;

			// check for invalid input
			if(choice > 5 || choice <= 0) {
				invalid++;
				continue;
			}

			// populate respective counts
			if(option == 1)
				result1[choice]++;
			else 
				result2[choice]++;
		}
		xfile.Close();

		// display report
		int i;
		int item = 0;

		m_Report.InsertItem(item,"Question A");
		item++;

		for(i = 1;i <= 4;i++) {
			str.Format("    Option %d",i);
			m_Report.InsertItem(item,str);

			str.Empty();
			if(result1[i] != 0)
				str.Format("%d",result1[i]);
			
			m_Report.SetItemText(item,1,str);
			item++;
		}
		m_Report.InsertItem(item,"");
		item++;

		m_Report.InsertItem(item,"Question B");
		item++;

		for(i = 1;i <= 5;i++) {
			str.Format("    Option %d",i);
			m_Report.InsertItem(item,str);

			str.Empty();
			if(result2[i] != 0)
				str.Format("%d",result2[i]);

			m_Report.SetItemText(item,1,str);
			item++;
		}
		
		if(invalid > 0) {
			m_Report.InsertItem(item,"");
			item++;

			m_Report.InsertItem(item,"Invalid");
			str.Format("%d",invalid);
			m_Report.SetItemText(item,1,str);
		}
	}
	catch(CFileException* e) {
		e->Delete();
		return;
	}
}
